﻿using System;

namespace tune2
{
    public class calcMatch
    {
        double real, c, l, freq, w;
        bool highpass;
        LCresult res = new LCresult();

        public calcMatch(double r, double cap, double ind, double frequenz, bool HP)
        {
            real = r;
            c = cap * 1e-12;
            l = ind * 1e-6;
            freq = frequenz * 1e6;
            w = 2 * Math.PI * freq;
            highpass = HP;
        }

        public LCresult calc()
        {
            // Berechne Imaginaerteil Xc oder Xl
            double img = -(1 / (w * c));
            if (l != 0) img = w * l;

            // img = Imaginärer Widerstand
            res.R = real;// + img * img / real;
            res.X = img;// + real * real / img;
            res.Z = Math.Sqrt(res.R * res.R + res.X * res.X);

            // Rp = real + img*img/real;
            // Xp = img + real*real/img;
            res.Rp = real + img*img/real;
            res.Xp = img + real*real/img;

            // calc match für alle Konfigurationen
            double tll = (50000.0 / w * Math.Sqrt(res.Rp / 50.0 - 1.0)) / 1000.0;
            double tlc = (100000000.0 / (w * res.Rp) * Math.Sqrt(res.Rp / 50.0 - 1.0) + 100000000.0 / (w * res.Xp)) / 100.0;
            double tllb = (1000.0 * real / w * Math.Sqrt(50.0 / real - 1.0) - 1000.0 * img / w) / 1000.0;
            double tlcb = (2000000.0 / w * Math.Sqrt(50.0 / real - 1.0)) / 100.0;
            double hll = (1000.0 / (w * Math.Sqrt(res.Rp / 50.0 - 1.0) / res.Rp - w / res.Xp)) / 1000.0;
            double hlc = (100000000.0 / Math.Sqrt(res.Rp / 50.0 - 1.0) / w / 50.0) / 100.0;
            double hllb = (50000.0 / (w * Math.Sqrt(50.0 / real - 1.0))) / 1000.0;
            double hlcb = (100.0 / (1.0 / (1000000.0 / (w * real * Math.Sqrt(50.0 / real - 1.0))) + 1.0 / (1000000.0 / (w * img)))) / 100.0;

            // ermittle das Ergebnis
            res.cap_pF = res.ind_uH =  0;

            try
            {
                if (!highpass)
                {
                    // Reactive L (Low Pass)
                    if (tll > 0.0 && tlc > 0.0)
                    {
                        // Ant > 50 Ohm
                        res.ind_uH = tll * 1e6;
                        res.cap_pF = tlc * 1e6;
                        res.LtoANT = true;
                    }
                    if (tllb > 0.0 && tlcb > 0.0)
                    {
                        // Ant < 50 Ohm
                        res.ind_uH = tllb * 1e6;
                        res.cap_pF = tlcb * 1e6;
                        res.LtoANT = false;
                    }
                }
                else
                {
                    // Reactive L (High Pass)
                    if (hll > 0.0 && hlc > 0.0)
                    {
                        // Ant > 50 Ohm
                        res.ind_uH = hll * 1e6;
                        res.cap_pF = hlc * 1e6;
                        res.LtoANT = true;
                    }
                    if (hllb > 0.0 && hlcb > 0.0)
                    {
                        // Ant < 50 Ohm
                        res.ind_uH = hllb * 1e6;
                        res.cap_pF = hlcb * 1e6;
                        res.LtoANT = false;
                    }
                }
            }
            catch { }

            return res;
        }
    }
}
