﻿using System;
using System.Collections.Generic;
using System.Threading;

namespace tune2
{
    class revcalc_proc
    {
        Thread revcalcthread;
        double L = 0, C = 0, oldL=0, oldC=0;
        bool anttrx = false, old_anttrx = false;
        double freq = 0, oldfreq = 0;
        List<LCresult> reslist = new List<LCresult>();
        public LCresult result;

        public revcalc_proc()
        {
            revcalcthread = new Thread(new ThreadStart(revcalc_loop));
            revcalcthread.Name = "revcalcthread";
            revcalcthread.IsBackground = true;  // damit wird er automatisch geschlossen wenn das Programm beendet wird
            revcalcthread.Start();
        }

        public void setValues(double f, double ind, double cap, bool atrx)
        {
            freq = f;
            L = ind;
            C = cap;
            anttrx = atrx;
        }

        void revcalc_loop()
        {
            while(true)
            {
                try
                {
                    if (L != oldL || C != oldC || anttrx != old_anttrx || freq != oldfreq)
                    {
                        oldL = L;
                        oldC = C;
                        old_anttrx = anttrx;
                        oldfreq = freq;

                        // scanne die Parameter durch und suche das beste Match
                        reslist.Clear();
                        for (double real = 1; real < 1000; real += 1)
                        {
                            // versuche es zuerst mit einer C-lastigen Antenne
                            for (double cap = 5; cap < 2000; cap += 5)
                            {
                                calcMatch cm = new calcMatch(real, cap, 0, freq, true);
                                LCresult res = cm.calc();

                                if (matched(res.cap_pF, C, 5) &&
                                    matched(res.ind_uH, L, 0.05) &&
                                    res.LtoANT == anttrx)
                                {
                                    res.searchL = 0;
                                    res.searchC = cap;
                                    res.searchR = real;
                                    reslist.Add(res);
                                }
                            }

                            // versuche es mit einer L-lastigen Antenne
                            for (double ind = 0.05; ind < 30; ind += 0.05)
                            {
                                calcMatch cm = new calcMatch(real, 0, ind, freq, true);
                                LCresult res = cm.calc();

                                if (matched(res.cap_pF, C, 5) &&
                                    matched(res.ind_uH, L, 0.05) &&
                                    res.LtoANT == anttrx)
                                {
                                    res.searchL = ind;
                                    res.searchC = 0;
                                    res.searchR = real;
                                    reslist.Add(res);
                                }
                            }
                        }

                        if (reslist.Count > 0)
                        {
                            // Werte wurden gefunden, suche den besten heraus
                            foreach (LCresult res in reslist)
                            {
                                res.diff = Math.Abs(res.cap_pF - C) + Math.Abs(res.ind_uH - L) * 1000;
                            }
                            LCresult bestres = reslist[0];
                            double bestdiff = 99999;
                            foreach (LCresult res in reslist)
                            {
                                if (res.diff < bestdiff)
                                {
                                    bestdiff = res.diff;
                                    bestres = res;
                                }
                            }
                            result = bestres;
                        }
                        else
                        {
                            LCresult r = new LCresult();
                            r.searchR = 99999999;
                            result = r;
                        }
                    }
                    else
                        Thread.Sleep(250);
                }
                catch
                {
                    Thread.Sleep(100);
                }
            }
        }

        bool matched(double vist, double vsoll, double acc)
        {
            if (vist >= (vsoll - acc) && vist <= (vsoll + acc)) return true;
            return false;
        }
    }
}
